
function [Qest nRatio countsArr] = combine_ph_datasets(startN,endN)


dirName = cd;
%atten = sscanf(dirName(strfind(dirName,'dB_')-3:strfind(dirName,'dB_')),'%f');
f_pulse = sscanf(dirName(strfind(dirName,'PulseF')+7:end),'%f*s');
Tpulse = sscanf(dirName(strfind(dirName,'Tpulse')+7:end),'%f*s')*1e-6;

dirInfo = dir(['PHcounts_intTime*']);
fileName = dirInfo(1).name;

Tint = sscanf(fileName(strfind(fileName,'intTime_')+8:end),'%f*s');




Tper = 1/f_pulse;
numChannels = 65536;
postbin = 500;
allCounts = zeros(numChannels, endN);
countsTotal = zeros(1, endN);
tbin = 0.512*(1:numChannels);
thresh = 0.00;
countThreshHigh = 1e9;
countThreshLow = 0;

badSets = filter3_reject_datasets(thresh);

numGoodSets = 0;
for k = startN:endN
    if ~ismember(k,badSets)
        numGoodSets = numGoodSets + 1;
        filename = sprintf(['PHcounts_intTime_' num2str(Tint) 'sec_fileNum%i_segment_1.mat'], k);
        allCounts(:,k) = importdata(filename);
        if sum(allCounts(:,k)) <= countThreshLow || sum(allCounts(:,k))>=countThreshHigh
            allCounts(:,k) = 0;
        end

%         startBin = 60;
%         endBin = startBin+round(Tpulse*1e9/(postbin*0.512));
        startBin = 1;
        endBin = floor(length(allCounts)*(33.51/33.51));

        countsTotal(k) = sum(allCounts((startBin:endBin),k));
        
        if sum(allCounts(:,k)) <= countThreshLow || sum(allCounts(:,k))>=countThreshHigh
            numGoodSets = numGoodSets - 1;
        end
    end
end

totCounts = sum(allCounts, 2);

if postbin > 1
    pb_counts = [];
    pb_t = [];
    for k = 1:length(totCounts)/postbin
        pb_counts(end+1) = sum(totCounts((k-1)*postbin+1:k*postbin));
        pb_t(end+1) = (k-1)*512e-12*postbin;
    end
end

countsArr = pb_counts.*Tper/(512e-12*postbin*Tint*numGoodSets);


%plot(tbin/1e3, totCounts.*Tper/(512e-12*Tint*numGoodSets),'g');

figure;
semilogy(pb_t/1e-6,countsArr,'.-b')
xlim([0 35])
xlabel('time (\mus)')
ylabel('count rate (Hz)')
title(['Tper = ' num2str(1e3/f_pulse) ' ms'])
legend([num2str(0.512*postbin) 'ns bin'])

figure;
plot((Tint/60+1.5)*(0:length(countsTotal)-1),countsTotal)
title(['Total Counts during Pulse ''On'' for each chunk'])
xlabel('time since integration starts(min)')


% figure();
% semilogy(pb_t/1e-6,countsArr,'.-b')
% xlim([0 35])
% xlabel('time (\mus)')
% ylabel('count rate (Hz)')
% legend([num2str(0.512*postbin) 'ns bin'])

end



function badSets = filter3_reject_datasets(thresh);

endInfo = dir('filter3_DAQV_End_*.txt');
startInfo = dir('filter3_DAQV_Initial_*.txt');

% sort endInfo
NumArr = [];
for k = 1:length(endInfo)
    fn = endInfo(k).name;
    NumArr = [NumArr sscanf(fn(findstr(fn,'Num'):end),'Num%d_%*s')]; 
end

indexArray = [NumArr', [1:length(endInfo)]'];
[values order] = sort(indexArray(:,1));

f3_end_voltagelog = []; f3_start_voltagelog = [];
for k = 1:length(endInfo)
    fn = endInfo(order(k)).name;
    f3_end_voltagelog = [f3_end_voltagelog load(endInfo(k).name)];
end

% sort startInfo
clear NumArr;
NumArr = [];
for k = 1:length(startInfo)
    fn = startInfo(k).name;
    NumArr = [NumArr sscanf(fn(findstr(fn,'Num'):end),'Num%d_%*s')]; 
end

indexArray = [NumArr', [1:length(startInfo)]'];
[values order] = sort(indexArray(:,1));


for k = 1:length(startInfo)
    fn = startInfo(order(k)).name;
    f3_start_voltagelog = [f3_start_voltagelog load(startInfo(k).name)];
end

f3_end_voltagelog = f3_end_voltagelog(2:end);
f3_start_voltagelog = f3_start_voltagelog(1:end-1);


ds = f3_end_voltagelog./f3_start_voltagelog;

badSets = find(ds < thresh | ds > 1.5);
length(badSets);
%plot(ds); xlabel('file index'); ylabel('Filter 3 DAQ voltage');

end
