function [optredwvl,optbluewvl,maxBlueCts] = reopt_dualwvls_bkup_measurementcondition(currredwvl,currbluewvl,redshitarray,blueshiftarray,readout_att,blue_att,fm)

% give current red wavelength and two arrays (in nm) of value to search
% around, both for red and blue, but this script will find blue wavelength
% blue shift array is a relative shift, so real blue shift is red shift +
% blueshift it self.

aom_det = 1.57e-3;

% currbluewvl = Painter.MatlabClientDLL.Run('arcturus.caltech.edu','laser_wavelength');
% currbluewvl = round(currbluewvl*10000)/10000; % round to 0.1pm
blueCtsArray = zeros(length(redshitarray),length(blueshiftarray));

for i = 1:length(redshitarray)
    
    sg_tone(0);
    pulse_gen_stop;
    switch_SPD_SPD(0);
    switch_SPD_filters(0);
    switch_SPD_extinction(0);
    switch_SPD_cavity(0);
    atten_set(60);
    Painter.MatlabClientDLL.Run('arcturus.caltech.edu','attenhp1_set',60);
    Painter.MatlabClientDLL.Run('arcturus.caltech.edu','attenhp2_set',60);
    
    
    redshift = redshitarray(i);
    parkingwvl = laser_wavelength;
    parkingwvl = round(parkingwvl*10000)/10000; % round to 0.1pm
    
    
    % move red wavelength slowly to target
    
    laser_lock_set((parkingwvl-(currredwvl - aom_det + redshift))*5/6 + (currredwvl - aom_det + redshift));
    pause(1);
    laser_lock_set((parkingwvl-(currredwvl - aom_det + redshift))*4/6 + (currredwvl - aom_det + redshift));
    pause(1);
    
    % do not need to lock filters along the way
    %     atten_set(3);
    %     switch_SPD_filters(1);
    %     sg_tone(1,fm,20);
    %     pause(1);
    %
    %     filter_lock_subroutine;
    
    laser_lock_set((parkingwvl-(currredwvl - aom_det + redshift))*3/6 + (currredwvl - aom_det + redshift));
    pause(1);
    laser_lock_set((parkingwvl-(currredwvl - aom_det + redshift))*2/6 + (currredwvl - aom_det + redshift));
    pause(1);
    
    %     filter_lock_subroutine;
    
    laser_lock_set((parkingwvl-(currredwvl - aom_det + redshift))*1/6 + (currredwvl - aom_det + redshift));
    pause(1);
    laser_lock_set(currredwvl - aom_det + redshift);
    %     pause(3);
    %
    %     filter_lock_subroutine;
    atten_set(3);
    switch_SPD_filters(1);
    sg_tone(1,fm,20);
    pause(1);
    
    filter_lock_subroutine;
    
    
    
    
    %     sg_tone(0);
    %     pulse_gen_stop;
    %     switch_SPD_SPD(0);
    %     switch_SPD_filters(0);
    %     switch_SPD_extinction(0);
    %     switch_SPD_cavity(0);
    %     atten_set(60);
    %     Painter.MatlabClientDLL.Run('arcturus.caltech.edu','attenhp1_set',60);
    %     Painter.MatlabClientDLL.Run('arcturus.caltech.edu','attenhp2_set',60);
    
    
    T_off = 200e-3;
    
    T_pre = (1291 + 148)*1e-9; % (s)
    T_bpulse = 200e-3; % CHANGED BY HAND.
    T_rpulse = 20e-6;%70e-9; % short readout pulse
    T_wait = 2200e-3-T_off; %200e-3;% % wait for any generated bath to fully decay
    
    %         % to use red long pulse:
    %         T_picoharp = T_pre + T_bpulse - 500e-9 - 30e-6 + 25e-6 +T_off; %T_pre + T_bpulse + T_off - 500e-9; % how long after T0 do we trigger picoharp
    
    % to look at end of blue pulse:
    T_picoharp = T_pre + T_bpulse - 500e-9 - 30e-6 + 0e-6; %use full window to look at blue.
    
    % === Set pulse train timing on Highland 1 (Highland 2 triggered by T0)
    pulse_gen_timing('A',1e-9,1e-6); % NOTHING
    pulse_gen_timing('B',((148 + 193)*1e-9 + T_bpulse + T_off), T_rpulse+350e-9); % L1 Agiltron
    pulse_gen_timing('C',((148 + 264)*1e-9 + T_bpulse + T_off),T_rpulse); % L1 AOM
    pulse_gen_timing('D',T_picoharp,4e-6);
    
    PulseF = 1./(T_pre + T_bpulse + T_off + T_rpulse + T_wait);
    pulse_gen_frequency(PulseF);
    
    
    
    
    
    for j = 1:length(blueshiftarray)
        
        blueshift = redshitarray(i)+blueshiftarray(j);
        
        
        parkingbluewvl = Painter.MatlabClientDLL.Run('arcturus.caltech.edu','laser_wavelength');
        parkingbluewvl = round(parkingbluewvl*10000)/10000; % round to 0.1pm
        
        % move blue wavelength slowly to target
        
        Painter.MatlabClientDLL.Run('arcturus.caltech.edu','laser_lock_set',((parkingbluewvl - (currbluewvl+blueshift))*2/3 + (currbluewvl+blueshift)));
        pause(1.5)
        Painter.MatlabClientDLL.Run('arcturus.caltech.edu','laser_lock_set',((parkingbluewvl - (currbluewvl+blueshift))*1/3 + (currbluewvl+blueshift)));
        pause(1.5)
        Painter.MatlabClientDLL.Run('arcturus.caltech.edu','laser_lock_set',((parkingbluewvl - (currbluewvl+blueshift))*0/3 + (currbluewvl+blueshift)));
        pause(2)
        
        laser_lock_set(currredwvl - aom_det/3*1 + redshift);
        pause(1);
        laser_lock_set(currredwvl - aom_det/3*2 + redshift);
        pause(1);
        laser_lock_set(currredwvl - aom_det + redshift);
        pause(2);
        
        
        atten_set(3);
        switch_SPD_filters(1);
        sg_tone(1,fm,20);
        pause(1);
        
        filter_lock_subroutine;
        
        % Move back to the measurement parking wavelength for laser 1
        laser_lock_set(currredwvl - aom_det/3*2 + redshift);
        pause(1);
        laser_lock_set(currredwvl - aom_det/3*1 + redshift);
        pause(1);
        laser_lock_set(currredwvl + redshift);
        pause(2);
        
        
        
        % Set up measurement path
        
        % Switch into extinction pulsing path and unblock lasers
        switch_SPD_extinction(1);
        
        % start generating pulses
        pulse_gen_start;
        pause(0.5);
        
        % readout (red) laser ON
        atten_set(readout_att);
        
        % drive (blue) laser ON
        Painter.MatlabClientDLL.Run('arcturus.caltech.edu','attenhp1_set',blue_att);
        
        % switch to real measurement optical path
        switch_SPD_cavity(1);
        switch_SPD_SPD(1);
        pause(15);
        
        
        [totCtsBlue] = periodic_save_monitor_cts_segment([pwd '\reoptwvl_blueCal_'], 90, 1, 1);
        fprintf(2, ['\nTotalcounts in this BLue chunk is ' num2str(totCtsBlue) '\n']);
        blueCtsArray(i,j) = totCtsBlue;
        
        
        sg_tone(0);
        pulse_gen_stop;
        switch_SPD_SPD(0);
        switch_SPD_filters(0);
        switch_SPD_extinction(0);
        switch_SPD_cavity(0);
        atten_set(60);
        Painter.MatlabClientDLL.Run('arcturus.caltech.edu','attenhp1_set',60);
        Painter.MatlabClientDLL.Run('arcturus.caltech.edu','attenhp2_set',60);
    end
end

[maxBlueCts,maxNum] = max(blueCtsArray(:));
[maxi,maxj] = ind2sub(size(blueCtsArray),maxNum);


optredwvl = currredwvl + redshitarray(maxi);
optbluewvl = currbluewvl + redshitarray(maxi)+blueshiftarray(maxj);
end


