load('nbar_error_vs_Toffs.mat');

%% fit exponential
f_mechanical = 5.014;
plotEnd = 2; %x axis in seconds
%GammaFitCurve = @(x,Toffs)(x(2) - (x(2) - x(3))*exp(-x(1)*Toffs));
GammaFitCurve = @(x,Toffs)(x(2)*exp(-x(1)*Toffs));
n1 = max(nbar);
n2 = min(nbar);
gammaGuess = 2*pi*5e9/estQcrude(min(nbar)/max(nbar),max(Toffs)-min(Toffs));
%x0 = [gammaGuess n1 n2];
x0 = [gammaGuess n1];
%initialCurve = (x0(2) - (x0(2) - x0(3))*exp(-x0(1)*linspace(0,plotEnd,1000)));
initialCurve = (x0(2)*exp(-x0(1)*linspace(0,plotEnd,1000)));
[fitParams, resnorm, resid, exitflag, output, lambda, J] = lsqcurvefit(GammaFitCurve,x0,Toffs,nbar);

%% interval
alpha = 0.1;
ci = nlparci(fitParams, resid, 'jacobian',J,'alpha',alpha);
EXPLower = ci(1,1); % ci( FIT VARIBALE INDEX NUMBER , LOWER OR UPPER EDGE OF INTERVAL)
EXPUpper = ci(1,2);

gamma_in_radians = fitParams(1);
n1Fit = fitParams(2);
%n2 = fitParams(3);
Q_final = f_mechanical/(gamma_in_radians/(2*pi))
%fitCurve = (n1Fit - (n1Fit - n2)*exp(-gamma_in_radians*linspace(0,plotEnd,1000)));
fitCurve = (n1Fit*exp(-gamma_in_radians*linspace(0,plotEnd,1000)));
fitCurveLow = (n1Fit*exp(-EXPLower*linspace(0,plotEnd,1000)));
fitCurveHigh = (n1Fit*exp(-EXPUpper*linspace(0,plotEnd,1000)));

%% plot
% scatter((Toffs)*1000,nbar,'bo','Filled');
errorbar((Toffs)*1000,nbar,nbarerror,'bo');
%set(gca,'yscale','log');
hold on;

plot(1000*linspace(0,plotEnd,1000),fitCurve,'r','LineWidth',2);
plot(1000*linspace(0,plotEnd,1000),fitCurveLow,'g','LineWidth',1);
plot(1000*linspace(0,plotEnd,1000),fitCurveHigh,'g','LineWidth',1);
% xlim([0 1000*Toffs(end)*1.1]); ylim([0 1.05*max(fitCurve)]);
xlim([0 1000*plotEnd]); 
ylim([0.1 1.05*max(fitCurve)]);
xlabel('T_{off} (ms)'); ylabel('<n>');
title(['Fitted Q: ' num2str(Q_final)]);
set(gca,'yscale','log');