% Function to evaluate sum of squares error between model data and real
% data

function [nbartonmod] = OMC_fitcurve_minocc(tondata, PARAMS)
    % INPUTS: PARAMS [2 x 1 array]. PARAMS(1) = Tf/30mK. PARAMS(2) = Acoeff.
    % Tf: (mK) thermalization base temp. scaled to units of 30mK so that
    % fit parameters are of same order of magnitude during optimization.
    %         Acoeff: order 1 coefficient for bath heating rate coeff A
    %         tondata: data array of tpulse times where nbarton will be
    %         evaluated
    [ton nbarton] = OMC_nbarton_eval(30e-3*PARAMS(1), PARAMS(2));
    nbartonmod = interp1(ton, nbarton, tondata);
    PARAMS
end

